@ECHO OFF
rem We check if CONFIG.SYS and AUTOEXEC.BAT exist.
IF NOT EXIST C:\CONFIG.SYS SET CONF=N
IF NOT EXIST C:\AUTOEXEC.BAT SET AUTOEXEC=N
rem If CONFIG.SYS and or AUTOEXEC.BAT, back them up as ".AFI" files.
IF EXIST C:\CONFIG.SYS COPY C:\CONFIG.SYS C:\CONFIG.AFI >> NUL 
IF EXIST C:\AUTOEXEC.BAT COPY C:\AUTOEXEC.BAT C:\AUTOEXEC.AFI >> NUL
CLS
VMODE 12
TYPE INTRO.TXT
PAUSE >> NUL
VMODE 2
rem Let the user make selections for drivers and the menu.
:SELECT
CLS
ECHO Install CD-ROM Driver?
CHOICE /C:YN
IF ERRORLEVEL 1 SET CDROMINST=Y
IF ERRORLEVEL 2 SET CDROMINST=N
ECHO.
ECHO Install Mouse Driver?
CHOICE /C:YN
IF ERRORLEVEL 1 SET MOUSEINST=Y
IF ERRORLEVEL 2 SET MOUSEINST=N
ECHO.
ECHO Install EMM386 (EMS Memory)?
CHOICE /C:YN
IF ERRORLEVEL 1 SET EMSINST=Y
IF ERRORLEVEL 2 SET EMSINST=N
ECHO.
ECHO Install Norton Commander?
CHOICE /C:YN
IF ERRORLEVEL 1 SET NCINST=Y
IF ERRORLEVEL 2 SET NCINST=N
ECHO.
ECHO MS-DOS Custom Startup Menu on boot? (To select which drivers to load.)
CHOICE /C:YN
IF ERRORLEVEL 1 SET MENU=Y
IF ERRORLEVEL 2 SET MENU=N
rem If the user chose to install a menu, warn them about needing to reinsert some config and autoexec entries.
IF "%MENU%"=="Y" GOTO MENUWARN
IF "%MENU%"=="N" GOTO SUMMARY
:MENUWARN
CLS
ECHO +===================================WARNING!==================================+
ECHO You have chosen to install an MS-DOS Custom Startup Menu.
ECHO This means that your startup files will be overwritten. (Backups will be made.)
ECHO -------------------------------------------------------------------------------
ECHO If something in your current startup files ALWAYS needs to load:
ECHO.
ECHO Open the "CONFIG.AFI" file and get any lines which need to load in CONFIG;
ECHO Put them at the top of "CONFIG.SYS" right above "[MENU]";
ECHO Open the "AUTOEXEC.AFI" file and get any lines which need to load in AUTOEXEC;
ECHO Put them at the top of "AUTOEXEC.BAT", right above "GOTO CONFIG%".
ECHO +=============================================================================+
ECHO.
ECHO When understood:
PAUSE
rem Ask the user to confirm if their choices are correct. If not, let them choose again. If yes, continue.
:SUMMARY
CLS
ECHO +=============================================+
ECHO I You have selected to install the following: I
ECHO +---------------------------------------------+
IF "%CDROMINST%"=="Y" ECHO I 1. CD-ROM Driver                            I
IF "%MOUSEINST%"=="Y" ECHO I 2. Mouse Driver                             I
IF "%EMSINST%"=="Y" ECHO I 3. EMM386 (EMS Memory) Driver               I
IF "%NCINST%"=="Y" ECHO I 4. Norton Commander                         I
IF "%MENU%"=="Y" ECHO I 5. MS-DOS Custom Startup Menu               I
ECHO +=============================================+
ECHO.
ECHO If the above is correct, press Y. If not, press N.
CHOICE /C:YN
IF ERRORLEVEL 2 GOTO SELECT
:CONTINUE
IF "%MENU%"=="N" GOTO CFG
rem The following just finds out what kind of menu we need to construct.
IF "%CDROMINST%"=="Y" IF "%MOUSEINST%"=="Y" IF "%EMSINST%"=="Y" IF "%MENU%"=="Y" GOTO BOTHEMS
IF "%CDROMINST%"=="Y" IF "%MOUSEINST%"=="Y" IF "%EMSINST%"=="N" IF "%MENU%"=="Y" GOTO BOTHXMS
IF "%CDROMINST%"=="Y" IF "%MOUSEINST%"=="N" IF "%EMSINST%"=="Y" IF "%MENU%"=="Y" GOTO CDEMS
IF "%CDROMINST%"=="Y" IF "%MOUSEINST%"=="N" IF "%EMSINST%"=="N" IF "%MENU%"=="Y" GOTO CDXMS
IF "%CDROMINST%"=="N" IF "%MOUSEINST%"=="Y" IF "%EMSINST%"=="Y" IF "%MENU%"=="Y" GOTO MOUSEEMS
IF "%CDROMINST%"=="N" IF "%MOUSEINST%"=="Y" IF "%EMSINST%"=="N" IF "%MENU%"=="Y" GOTO MOUSEXMS
IF "%CDROMINST%"=="N" IF "%MOUSEINST%"=="N" IF "%EMSINST%"=="Y" IF "%MENU%"=="Y" GOTO NONEEMS
IF "%CDROMINST%"=="N" IF "%MOUSEINST%"=="N" IF "%EMSINST%"=="N" IF "%MENU%"=="Y" GOTO NONEXMS
IF "%CDROMINST%"=="N" IF "%MOUSEINST%"=="N" IF "%EMSINST%"=="N" IF "%MENU%"=="N" GOTO NONEWARN

rem The following puts all the common lines in config, and copies the drivers for whatever type of menu.
:BOTHEMS
MD C:\DRIVERS
IF "%CONF%"=="Y" DEL C:\CONFIG.SYS
IF "%AUTOEXEC%"=="Y" DEL C:\AUTOEXEC.BAT
ECHO. >> C:\CONFIG.SYS
ECHO FILES=40 >> C:\CONFIG.SYS
ECHO BUFFERS=20 >> C:\CONFIG.SYS
ECHO STACKS=16,256 >> C:\CONFIG.SYS
ECHO DOS=HIGH,UMB >> C:\CONFIG.SYS
ECHO LASTDRIVE=Z >> C:CONFIG.SYS
TYPE ALLEMS.SYS >> C:\CONFIG.SYS
COPY AUTOEXEC.BAT C:\
COPY VIDE-CDD.SYS C:\DRIVERS
COPY MOUSE.EXE C:\DRIVERS
COPY MSCDEX.EXE C:\DRIVERS
COPY EMM386.EXE C:\DRIVERS
COPY HIMEM.SYS C:\DRIVERS
IF "%NCINST%"=="Y" PKUNZIP A:\NC.ZIP C:\ -OD
IF "%NCINST%"=="Y" ECHO LH C:\NC\NC.EXE >> C:\AUTOEXEC.BAT
GOTO END

:BOTHXMS
MD C:\DRIVERS
IF "%CONF%"=="Y" DEL C:\CONFIG.SYS
IF "%AUTOEXEC%"=="Y" DEL C:\AUTOEXEC.BAT
ECHO. >> C:\CONFIG.SYS
ECHO FILES=40 >> C:\CONFIG.SYS
ECHO BUFFERS=20 >> C:\CONFIG.SYS
ECHO STACKS=16,256 >> C:\CONFIG.SYS
ECHO DOS=HIGH,UMB >> C:\CONFIG.SYS
ECHO LASTDRIVE=Z >> C:CONFIG.SYS
TYPE ALLXMS.SYS >> C:\CONFIG.SYS
COPY AUTOEXEC.BAT C:\
COPY VIDE-CDD.SYS C:\DRIVERS
COPY MOUSE.EXE C:\DRIVERS
COPY MSCDEX.EXE C:\DRIVERS
COPY HIMEM.SYS C:\DRIVERS
IF "%NCINST%"=="Y" PKUNZIP A:\NC.ZIP C:\ -OD
IF "%NCINST%"=="Y" ECHO LH C:\NC\NC.EXE >> C:\AUTOEXEC.BAT
GOTO END

:CDEMS
MD C:\DRIVERS
IF "%CONF%"=="Y" DEL C:\CONFIG.SYS
IF "%AUTOEXEC%"=="Y" DEL C:\AUTOEXEC.BAT
ECHO. >> C:\CONFIG.SYS
ECHO FILES=40 >> C:\CONFIG.SYS
ECHO BUFFERS=20 >> C:\CONFIG.SYS
ECHO STACKS=16,256 >> C:\CONFIG.SYS
ECHO DOS=HIGH,UMB >> C:\CONFIG.SYS
ECHO LASTDRIVE=Z >> C:CONFIG.SYS
TYPE CDEMS.SYS >> C:\CONFIG.SYS
COPY AUTOEXEC.BAT C:\
COPY VIDE-CDD.SYS C:\DRIVERS
COPY MSCDEX.EXE C:\DRIVERS
COPY EMM386.EXE C:\DRIVERS
COPY HIMEM.SYS C:\DRIVERS
IF "%NCINST%"=="Y" PKUNZIP A:\NC.ZIP C:\ -OD
IF "%NCINST%"=="Y" ECHO LH C:\NC\NC.EXE >> C:\AUTOEXEC.BAT
GOTO END

:CDXMS
MD C:\DRIVERS
IF "%CONF%"=="Y" DEL C:\CONFIG.SYS
IF "%AUTOEXEC%"=="Y" DEL C:\AUTOEXEC.BAT
ECHO. >> C:\CONFIG.SYS
ECHO FILES=40 >> C:\CONFIG.SYS
ECHO BUFFERS=20 >> C:\CONFIG.SYS
ECHO STACKS=16,256 >> C:\CONFIG.SYS
ECHO DOS=HIGH,UMB >> C:\CONFIG.SYS
ECHO LASTDRIVE=Z >> C:CONFIG.SYS
TYPE CDXMS.SYS >> C:\CONFIG.SYS
COPY AUTOEXEC.BAT C:\
COPY VIDE-CDD.SYS C:\DRIVERS
COPY MSCDEX.EXE C:\DRIVERS
COPY HIMEM.SYS C:\DRIVERS
IF "%NCINST%"=="Y" PKUNZIP A:\NC.ZIP C:\ -OD
IF "%NCINST%"=="Y" ECHO LH C:\NC\NC.EXE >> C:\AUTOEXEC.BAT
GOTO END

:MOUSEEMS
MD C:\DRIVERS
IF "%CONF%"=="Y" DEL C:\CONFIG.SYS
IF "%AUTOEXEC%"=="Y" DEL C:\AUTOEXEC.BAT
ECHO. >> C:\CONFIG.SYS
ECHO FILES=40 >> C:\CONFIG.SYS
ECHO BUFFERS=20 >> C:\CONFIG.SYS
ECHO STACKS=16,256 >> C:\CONFIG.SYS
ECHO DOS=HIGH,UMB >> C:\CONFIG.SYS
ECHO LASTDRIVE=Z >> C:CONFIG.SYS
TYPE MOUSEEMS.SYS >> C:\CONFIG.SYS
COPY AUTOEXEC.BAT C:\
COPY MOUSE.EXE C:\DRIVERS
COPY EMM386.EXE C:\DRIVERS
COPY HIMEM.SYS C:\DRIVERS
IF "%NCINST%"=="Y" PKUNZIP A:\NC.ZIP C:\ -OD
IF "%NCINST%"=="Y" ECHO LH C:\NC\NC.EXE >> C:\AUTOEXEC.BAT
GOTO END

:MOUSEXMS
MD C:\DRIVERS
IF "%CONF%"=="Y" DEL C:\CONFIG.SYS
IF "%AUTOEXEC%"=="Y" DEL C:\AUTOEXEC.BAT
ECHO. >> C:\CONFIG.SYS
ECHO FILES=40 >> C:\CONFIG.SYS
ECHO BUFFERS=20 >> C:\CONFIG.SYS
ECHO STACKS=16,256 >> C:\CONFIG.SYS
ECHO DOS=HIGH,UMB >> C:\CONFIG.SYS
ECHO LASTDRIVE=Z >> C:CONFIG.SYS
TYPE MOUSEXMS.SYS >> C:\CONFIG.SYS
COPY AUTOEXEC.BAT C:\
COPY MOUSE.EXE C:\DRIVERS
COPY HIMEM.SYS C:\DRIVERS
IF "%NCINST%"=="Y" PKUNZIP A:\NC.ZIP C:\ -OD
IF "%NCINST%"=="Y" ECHO LH C:\NC\NC.EXE >> C:\AUTOEXEC.BAT
GOTO END

:NONEEMS
IF "%CONF%"=="Y" DEL C:\CONFIG.SYS
IF "%AUTOEXEC%"=="Y" DEL C:\AUTOEXEC.BAT
ECHO. >> C:\CONFIG.SYS
ECHO FILES=40 >> C:\CONFIG.SYS
ECHO BUFFERS=20 >> C:\CONFIG.SYS
ECHO STACKS=16,256 >> C:\CONFIG.SYS
ECHO DOS=HIGH,UMB >> C:\CONFIG.SYS
ECHO LASTDRIVE=Z >> C:CONFIG.SYS
TYPE EMSONLY.SYS >> C:\CONFIG.SYS
COPY AUTOEXEC.BAT C:\
COPY EMM386.EXE C:\DRIVERS
COPY HIMEM.SYS C:\DRIVERS
IF "%NCINST%"=="Y" PKUNZIP A:\NC.ZIP C:\ -OD
IF "%NCINST%"=="Y" ECHO LH C:\NC\NC.EXE >> C:\AUTOEXEC.BAT
GOTO END

:NONEXMS
IF "%CONF%"=="Y" DEL C:\CONFIG.SYS
IF "%AUTOEXEC%"=="Y" DEL C:\AUTOEXEC.BAT
ECHO. >> C:\CONFIG.SYS
ECHO FILES=40 >> C:\CONFIG.SYS
ECHO BUFFERS=20 >> C:\CONFIG.SYS
ECHO STACKS=16,256 >> C:\CONFIG.SYS
ECHO DOS=HIGH,UMB >> C:\CONFIG.SYS
ECHO LASTDRIVE=Z >> C:CONFIG.SYS
TYPE XMSONLY.SYS >> C:\CONFIG.SYS
COPY AUTOEXEC.BAT C:\
COPY HIMEM.SYS C:\DRIVERS
IF "%NCINST%"=="Y" PKUNZIP A:\NC.ZIP C:\ -OD
IF "%NCINST%"=="Y" ECHO LH C:\NC\NC.EXE >> C:\AUTOEXEC.BAT
GOTO END

rem The following puts all the correct lines in autoexec and config for no menu and copies all the correct files.
:CFG
MD C:\DRIVERS
IF "%CDROMINST%"=="Y" COPY VIDE-CDD.SYS C:\DRIVERS
IF "%CDROMINST%"=="Y" COPY MSCDEX.EXE C:\DRIVERS
IF "%MOUSEINST%"=="Y" COPY MOUSE.EXE C:\DRIVERS
IF "%EMSINST%"=="Y" COPY EMM386.EXE C:\DRIVERS
IF "%CONF%"=="N" ECHO. >> C:\CONFIG.SYS
IF "%AUTOEXEC%"=="N" ECHO @ECHO OFF >> C:\AUTOEXEC.BAT
IF "%CONF%"=="N" COPY HIMEM.SYS C:\DRIVERS
IF "%CONF%"=="N" ECHO FILES=40 >> C:\CONFIG.SYS
IF "%CONF%"=="N" ECHO BUFFERS=20 >> C:\CONFIG.SYS
IF "%CONF%"=="N" ECHO STACKS=16,256 >> C:\CONFIG.SYS
IF "%CONF%"=="N" ECHO DEVICE=C:\DRIVERS\HIMEM.SYS >> C:\CONFIG.SYS
IF "%CONF%"=="N" ECHO DOS=HIGH,UMB >> C:\CONFIG.SYS
IF "%EMSINST%"=="Y" ECHO DEVICE=C:\DRIVERS\EMM386.EXE AUTO >> C:\CONFIG.SYS
IF "%CDROMINST%"=="Y" ECHO DEVICEHIGH=C:\DRIVERS\VIDE-CDD.SYS /D:MSCD001 >> C:\CONFIG.SYS
IF "%CDROMINST%"=="Y" ECHO LASTDRIVE=Z >> C:\CONFIG.SYS
IF "%CDROMINST%"=="Y" ECHO LH C:\DRIVERS\MSCDEX.EXE /D:MSCD001 /L:Z >> C:\AUTOEXEC.BAT
IF "%MOUSEINST%"=="Y" ECHO LH C:\DRIVERS\MOUSE.EXE >> C:\AUTOEXEC.BAT
ECHO CLS >> C:\AUTOEXEC.BAT
ECHO ECHO XMS memory available. >> C:\AUTOEXEC.BAT
IF "%EMSINST%"=="Y" ECHO ECHO EMS memory available. >> C:\AUTOEXEC.BAT
IF "%CDROMINST%"=="Y" ECHO ECHO CD-ROM drive installed at drive Z:. >> C:\AUTOEXEC.BAT
IF "%MOUSEINST%"=="Y" ECHO ECHO Mouse driver installed. >> C:\AUTOEXEC.BAT
ECHO ECHO. >> C:\AUTOEXEC.BAT
IF "%NCINST%"=="Y" PKUNZIP A:\NC.ZIP C:\ -OD
IF "%NCINST%"=="Y" ECHO LH C:\NC\NC.EXE >> C:\AUTOEXEC.BAT
GOTO END

:NONEWARN
CLS
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO.
ECHO                  +------------------------------------------+
ECHO                  I==================ERROR!==================I
ECHO                  +------------------------------------------+
ECHO                  I You have denied all choices.             I
ECHO                  I The installer cannot continue this way.  I
ECHO                  I Press any key to go back to the choices. I
ECHO                  +==========================================+
PAUSE >> NUL
GOTO SELECT

rem Tell the user that the installation finished, and say what it installed.
:END
CLS
ECHO +=============================================================+
ECHO I MS-DOS After Installation Pack installed the following:     I
ECHO +-------------------------------------------------------------+
IF "%CDROMINST%"=="Y" ECHO I 1. CD-ROM Driver                                            I
IF "%MOUSEINST%"=="Y" ECHO I 2. Mouse Driver                                             I
IF "%EMSINST%"=="Y" ECHO I 3. EMM386 (EMS Memory Driver)                               I
IF "%NCINST%"=="Y" ECHO I 4. Norton Commander                                         I
IF "%MENU%"=="Y" ECHO I 5. MS-DOS Custom Startup Menu Options                       I
rem If we made backups of config and autoexec, tell the user that we did and what they are named.
IF EXIST C:\*.AFI ECHO +-------------------------------------------------------------+
IF EXIST C:\CONFIG.AFI ECHO I Your old MS-DOS "CONFIG.SYS" was saved as "CONFIG.AFI".     I
IF EXIST C:\AUTOEXEC.AFI ECHO I Your old MS-DOS "AUTOEXEC.BAT" was saved as "AUTOEXEC.AFI". I
ECHO +-------------------------------------------------------------+
ECHO I                 Enjoy your new MS-DOS setup!                I
ECHO +=============================================================+